#ifndef EUROFUCKSIMULATOR_H
#define EUROFUCKSIMULATOR_H

#include "EuroFuckSimulator_global.h"

#include <functional>

#include "telemetry.h"
#include "gui/gui.h"

class EUROFUCKSIMULATOR_EXPORT EuroFuckSimulator: public QObject
{
    Q_OBJECT;
private:

    Gui* gui;


    // speed module
    double speedSineX = 0.0;
    double speedMaxMPH = 70.0;
    double speedWaveFreq = 2.5;
    double speedWaveAmp = 0.25;
    double speedWeight = 0.75;

    // rpm module
    double rpmRate = 1500.0; // RPM for full power
    double rpmWeight = 0.25;

    // punishment module
    double punishmentTimeRate = 1.0 / 500.0; // punishment time (seconds) per euro fined
    double punishmentMultiplier = 0.1;       //

    // job reward module
    double rewardTimeRate = 30.0 / 1500.0;    // reward time (seconds) per euro earned

    // distance reward module
//    double

    // crash module?
    double crashTime = 0.5;                  // time the motor runs at full power after a crash

    //


public:
    EuroFuckSimulator();
    ~EuroFuckSimulator() = default;


};

#endif // EUROFUCKSIMULATOR_H
