#ifndef FANCYSLIDER_H
#define FANCYSLIDER_H

#include <QWidget>
#include <QSlider>
#include <QSpinBox>
#include <QLabel>

class FancySlider : public QWidget
{
    Q_OBJECT;

    Q_PROPERTY(double value READ getValue WRITE setValue NOTIFY valueChanged);
public:
    explicit FancySlider(QWidget *parent = nullptr);

    double getValue() {return value;}
    double getMin() {return min;}
    double getMax() {return max;}

private:
    QSlider* slider;
    QDoubleSpinBox* box;
    QLabel* label;

    void updateValues();

    double value;
    double min = 0.0;
    double max = 100.0;

    int sliderResolution = 1000.0;

public slots:
    Q_SLOT void setValue(double value);
    void setMin(double newMin) {min = newMin; updateValues();}
    void setMax(double newMax) {max = newMax; updateValues();}

signals:
    void valueChanged(double value);

};

#endif // FANCYSLIDER_H
